=== debian/changelog ===
endless-sky (0.10.2-1) unstable; urgency=medium

  * d/watch: add stanza matching github tags
  * add debian/gbp.conf pointing to debian/unstable branch
  * New upstream version 0.9.16.1 (Closes: #944757)
    + add .winmake (new) to d/copyright
    + d/copyright: update with upstream changes
    + drop 0001-fix-Add-missing-string-include.patch applied upstream
    + drop 0001-build-fix-compilation-on-gcc11.patch adopted upstream
    + drop executable bits from files under sounds/
  * bump debhelper compatibility level from 9 to 13
  * install usr/share/metainfo in endless-sky binary package
    fixes dh_missing error with debhelper compatibility level 13
  * include bindnow hardening compile flags
  * copyright:
    + add pointer to full CC0 text
    + fix indentation of continuation line
    + replace spaces in Files: patterns with '?'
    + fix cc-by-2.0 reference, add license text
    + fix pointer to CC0 license in /usr/share
    + fix reference to CC0
    + fix PD and CC0 license values
    + add PD and CC-BY-3.0 license stanzas
    + add proper copyright attribution for the appdata xml, thanks lintian
    + move licensing explanations to a Comment: field
    + add myself to debian/* copyright holders
  * override tons of lintian complaints about documentation outside of doc/
  * take over package maintenance under Games team umbrella.
    Previous maintainer consent:
    https://lists.debian.org/debian-devel-games/2022/11/msg00008.html
  * add Vcs-* headers
  * fix Exec= path in the .desktop file
  * New upstream version 0.10.2
    (Closes: #1037644 -- FTBFS with gcc-13)
  * disable VCPKG CMake plugin
    tries to download stuff during build
  * replace libgl1-mesa-dev build-dependency with libgl-dev
  * switch to cmake+ninja build system, thanks to Trent W. Buck
    also add xvfb and xauth to build-dependencies to make the tests run
  * fix/rearrange copyright stancas
    make more general ones come before more specific patterns
    remove patterns no longer matching existing content
  * bimp policy compliance version to 4.6.2 (no changes needed)
  * patch endless-sky.6 to fix warnings from troff
  * patch out two small spelling mistakes
  * update long description; thanks to Trent W. Buck <trentbuck@gmail.com>
  * run tests "manually" and skip slow debug tests

 -- Damyan Ivanov <dmn@debian.org>  Fri, 11 Aug 2023 14:20:26 +0000

endless-sky (0.9.8-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Add upstream fix for FTBFS with gcc 11. (Closes: #984050)

 -- Adrian Bunk <bunk@debian.org>  Thu, 09 Dec 2021 19:56:16 +0200

endless-sky (0.9.8-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix ftbfs with GCC-10. (Closes: #957175)
    - Used upstream patch.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Wed, 26 Aug 2020 10:49:19 +0100
