=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -53,12 +53,14 @@
 	integration/config/plugins/integration-tests/data/tests/tests_framework.txt
 	integration/config/plugins/integration-tests/data/tests/tests_hyperjumps_to_autocondition.txt
 	integration/config/plugins/integration-tests/data/tests/tests_illegal_atrocity.txt
+	integration/config/plugins/integration-tests/data/tests/tests_take_ships.txt
 	integration/config/plugins/integration-tests/data/tests/tests_save_load.txt
 	integration/config/plugins/integration-tests/data/tests/tests_ship_sale.txt
 	integration/config/plugins/integration-tests/data/tests/tests_shipyard_outfitter_missions.txt
 	integration/config/plugins/integration-tests/data/tests/tests_store_outfits_on_take_off.txt
 	integration/config/plugins/integration-tests/data/tests/tests_to_accept.txt
 	integration/config/plugins/integration-tests/data/tests/tests_wormhole_navigation.txt
+	integration/config/plugins/integration-tests/data/tests/tests_installed_plugin.txt
 )
 
 target_include_directories(EndlessSkyTests PRIVATE unit/include)
