=== debian/changelog ===
endless-sky (0.10.4-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:49:01 +1100

endless-sky (0.10.4-1build1) noble; urgency=medium

  * No-change rebuild against libpng16-16t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 29 Feb 2024 06:26:46 +0000

endless-sky (0.10.4-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 0.10.4. (Closes: #1059987)
  * Rebase debian/patches

  [ Alexandre Detiste ]
  * Mark huge data package "Multi-Arch: foreign"

 -- Bo YU <tsu.yubo@gmail.com>  Wed, 17 Jan 2024 21:29:08 +0800

endless-sky (0.10.2-6) unstable; urgency=medium

  [ Adrian Bunk ]
  * Increase test timeout and make test failures fatal again

 -- Damyan Ivanov <dmn@debian.org>  Tue, 10 Oct 2023 14:57:15 +0000

endless-sky (0.10.2-5) unstable; urgency=medium

  * skip tests on hppa too (Closes: #1053733)

 -- Damyan Ivanov <dmn@debian.org>  Tue, 10 Oct 2023 12:26:11 +0000

endless-sky (0.10.2-4) unstable; urgency=medium

  * fix retrieval of build architecture
  * skip tests also on hurd-i386
  * d/copyright: clarify multiple patterns leading to redundancy
  * d/control: add Rules-Requires-Root: no

 -- Damyan Ivanov <dmn@debian.org>  Fri, 06 Oct 2023 13:28:14 +0000

endless-sky (0.10.2-3) unstable; urgency=medium

  * add explicit build-dependency on uuid-dev
  * skip tests in riscv64 (timeouts)
  * also skip tests in ia64, powerpc and x32 (never passed before)

 -- Damyan Ivanov <dmn@debian.org>  Fri, 06 Oct 2023 08:26:36 +0000

endless-sky (0.10.2-2) unstable; urgency=medium

  * patch in -latomic fixing linking on armel/mipsel

 -- Damyan Ivanov <dmn@debian.org>  Thu, 05 Oct 2023 10:09:04 +0000
