=== debian/control ===
--- 
+++ 
@@ -1,5 +1,6 @@
 Source: endless-sky
-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders: Damyan Ivanov <dmn@debian.org>
 Section: games
 Priority: optional
@@ -19,8 +20,10 @@
  libsdl2-dev,
  libmad0-dev,
  ninja-build,
+ uuid-dev,
  xauth <!nocheck>,
  xvfb <!nocheck>
+Rules-Requires-Root: no
 
 Package: endless-sky
 Architecture: any
@@ -50,6 +53,7 @@
 
 Package: endless-sky-data
 Architecture: all
+Multi-Arch: foreign
 Depends:
  ${misc:Depends}
 Description: space exploration, trading and combat game - data files
