=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/endless-sky-$1\.tar\.gz/ \
  https://github.com/endless-sky/endless-sky/releases .*/v?(\d\S*)\.tar\.gz
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*@ARCHIVE_EXT@)%@PACKAGE@-$1%" \
      https://github.com/endless-sky/endless-sky/tags \
      (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@
