=== debian/changelog ===
endless-sky (0.10.5-1mx23+1) mx; urgency=medium

  * Unstable release build for MX-23.
  * Added scons & uuid to the depends list.

 -- Mike Purtell <mmikeinsantarosa@mxlinux.org>  Thu, 15 Feb 2024 14:14:50 -0800

endless-sky (0.10.4-1mx23+1) mx; urgency=medium

  * Rebuild for MX-23.

 -- Mike Purtell <mmikeinsantarosa@mxlinux.org>  Thu, 09 Nov 2023 12:20:05 -0800

endless-sky (0.10.2-1mx23+1) mx; urgency=medium

  * Rebuild for MX-23.

 -- Mike Purtell <mmikeinsantarosa@mxlinux.org>  Sun, 13 Aug 2023 12:26:59 -0700
